// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "component/display/material/Material.hpp"
#include "display/shader/SimpleTexturedShader.hpp"

namespace Dawn {
  class SimpleTexturedMaterial : public Material {
    private:
      struct SimpleTexturedShaderData data;

    public:
      /**
       * Returns the color of this material.
       */
      struct Color getColor();

      /**
       * Sets the color of this material.
       * 
       * @param color The color to set.
       */
      void setColor(struct Color color);

      std::vector<std::shared_ptr<IRenderPass>> getPasses(
        struct RenderPassContext &ctx
      ) override;
  };
}